use std::{cell::RefCell, rc::Rc};

fn c<F: FnOnce() + 'static>(f: F) {
    f();
}

fn main() {
    let v = Rc::new(RefCell::new(vec![1, 2, 3]));

    c({
        let v = v.clone();
        move || {
            println!("inner 1: {:?}", v);
            v.replace_with(|old| {
                old.push(4);
                old.to_vec()
            });
        }
    });
    c({
        let v = v.clone();
        move || {
            println!("inner 2: {:?}", v);
            // This seems more readable than the example from https://www.youtube.com/watch?v=FTsaDmf0f_0 shown above
            v.borrow_mut().push(5);
        }
    });

    println!("outer: {:?}", v);
}
